package com.mdd.admin.socket.client;

import java.net.URI;
import org.java_websocket.client.WebSocketClient;
import org.java_websocket.enums.ReadyState;
import org.java_websocket.handshake.ServerHandshake;

public class MyWebSocketClient extends WebSocketClient {
   private boolean isClosed = false;

   public MyWebSocketClient(URI serverUri) {
      super(serverUri);
   }

   public void onOpen(ServerHandshake handshakedata) {
      System.out.println("New connection opened");
   }

   public void onMessage(String message) {
      System.out.println("Received: " + message);
   }

   public void onClose(int code, String reason, boolean remote) {
      System.out.println("Connection closed by " + (remote ? "remote peer" : "us") + " Code: " + code + " Reason: " + reason);
      this.isClosed = true;
   }

   public void onError(Exception ex) {
      ex.printStackTrace();
      this.tryClose();
   }

   public void start() {
      this.connect();
   }

   public void sendMessage(String message) {
      if (!this.isClosed && this.getReadyState() == ReadyState.OPEN) {
         this.send(message);
      } else {
         System.out.println("WebSocket is closed or not connected");
      }

   }

   public void tryClose() {
      if (!this.isClosed && this.getReadyState() != ReadyState.CLOSED) {
         this.close();
      }

   }
}
